/*
 * Copyright (C), 2000-2002 by Contributors to the monit codebase. 
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>

#include "monitor.h"
#include "monit_process.h"

/**
 *  General purpose /proc methods.
 *
 *  @author Jan-Henrik Haukeland, <hauk@tildeslash.com>
 *  @author Christian Hopp <chopp@iei.tu-clausthal.de>
 *
 *  @version \$Id$
 *
 *  @file
 */

/* ------------------------------------------------------------------ Public */

int include_children= TRUE;
char actionnames[][STRLEN]={"ignore", "alert", "restart", "stop"};
char operatornames[][STRLEN]={"greater", "less", "equal", "not equal"};

/**
 * Initilize the proc information code
 * @return TRUE if succeeded otherwise FALSE.
 */
int init_process_info(void) {

  if ( ! init_process_info_sysdep ()) {

    return FALSE;

  }

  return TRUE;

}

/**
 * Get the proc infomation (CPU percentage, MEM in MByte and percent,
 * status), enduser version. 
 * @param p proc information structure to work with.
 * @return TRUE if succeeded otherwise FALSE.
 */

int update_process_data(Process_T p, pid_t pid) {

  Proc_Info_T pi= p->procinfo;

  pi->pid=pid;

  if (! get_process_info(pi)) {

    return FALSE;
    
  } 

  return TRUE;
}

/**
 * Compare a value within a resource list member
 * @param value the value to compare
 * @param q resouce list member
 * @return result of comparison, either TRUE or FALSE
 */

int compare_resource(int value, Resource_T q) {

  switch ( q->operator ) {

  case RESOURCE_OPERATOR_GREATER:
    if ( value > q->limit ) {

      return TRUE;

    } else {

      return FALSE;

    }

  case RESOURCE_OPERATOR_LESS:
    if ( value < q->limit ) {

      return TRUE;

    } else {

      return FALSE;

    }

  case RESOURCE_OPERATOR_EQUAL:
    if ( value = q->limit ) {

      return TRUE;

    } else {

      return FALSE;

    }

  case RESOURCE_OPERATOR_NOTEQUAL:
    if ( value != q->limit ) {

      return TRUE;

    } else {

      return FALSE;

    }

  default: 

    log("Unknow resource comparison operator.\n");

    return FALSE;

  }
}
