/*
 * Copyright (C), 2000-2002 by Contributors to the monit codebase. 
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef MONIT_PROCESS_H
#define MONIT_PROCESS_H

#include <unistd.h>
#include "monitor.h"

#define PROCESS_ZOMBIE        1

extern int include_children;
extern char actionnames[][STRLEN];
extern char operatornames[][STRLEN];

#define RESOURCE_ID_CPU_PERCENT 1
#define RESOURCE_ID_MEM_PERCENT 2
#define RESOURCE_ID_MEM_KBYTE   3

#define RESOURCE_ACTION_IGNORE  0
#define RESOURCE_ACTION_ALERT   1 
#define RESOURCE_ACTION_RESTART 2 
#define RESOURCE_ACTION_STOP    3

#define RESOURCE_OPERATOR_GREATER  0
#define RESOURCE_OPERATOR_LESS     1
#define RESOURCE_OPERATOR_EQUAL    2
#define RESOURCE_OPERATOR_NOTEQUAL 3

int update_process_data(Process_T p, pid_t pid);
int init_process_info(void);
int compare_resource(int, Resource_T);

#endif

